﻿;Jumpi-Game v. 0.05

UsePNGImageDecoder()
If InitEngine3D()
  InitSprite()
EndIf
InitMouse()
InitKeyboard()
InitSound()
UseOGGSoundDecoder()

Add3DArchive(#PB_Compiler_Home+"Examples/3D/Data/GUI", #PB_3DArchive_FileSystem)
Add3DArchive(#PB_Compiler_Home + "examples/3d/Data/Textures", #PB_3DArchive_FileSystem)

;Game
Global enemy_anz.l = 0
Global plattform_anz.l = 0
Global jplatt = #False
Global anim_count.l = 0
#MAX_GAME_SPEED = 40
Global up.b = #False, down.b = #False, left.b = #False, right.b = #False, upLeft.b = #False, upRight.b = #False, fire.b = #False
Global sprAnz.l = 6
Global score.l = 0, lives.l = 3
Global stopDraw = #False
Global timer.w = 0
#OUT = -9999
Global screenTimer.l = 0
Global lifes = 3
Global ammo = 5
Global explosionTime = 0

#S_UP = 0
#S_DOWN = 1
#S_LEFT = 2
#S_RIGHT = 3

;Screen
Structure TTb
  w.l
  h.l
  rand.f
EndStructure

Global tb.TTb

;Sprite-Typen
#PLAYER = 0
#BULLET = 1
#ENEMY = 2

Structure TObject
  type.w
  ;Merkmale
  id.l
  frameAnz.w
  x.l : y.l : w.l : h.l : speed.l
  hit.b
  dir.w
  ;Animation
  frame.w
  min.w
  max.w
  steps.w
  eventFrame.w
  drawAlways.b
  ;JnR
  jump.b
  fall.b
  jumpStep.w
  ;Z-Order
  depth.w
  ;Bullet
  spd_x.w
  spd_y.w
EndStructure

Global NewList bullet.TObject() 

;Sprites setzen
Global sprPlayer, sprEnemy, sprPlattform, sprBullet, sprTiles, sprExplosion, sprBackground, sprSchnee

Global player.TObject
Global Dim enemy.TObject(99)
Global bullet.TObject

Global Dim plattform.TObject(10)

Global bdraw = #False

;Parallax
Global actor_xt.l, actor_yt.l
;Parallax-Scrolling
Structure Scrolling
  Sprite.i
  PositionX.i
  PositionY.i
EndStructure
Global Background.Scrolling
;Hintergrundbild beliebiger Größe, das langsamer als der Vordergrund gescrollt wird.
Global init = #True
Global bg_x = 0 ;Referenzpunkt
Global bg_y = 0
Global bg_w, bg_h
Global actorOldxt = 0, actorOldyt = 0
Global xt, yt

;Level
Global Dim levelMap.l(2000, 2000)
Global tiles_w.l, tiles_h.l
#RASTER = 32

#L_EMPTY = -1
#L_MINE = 8
#L_PLAYER = 149
#L_ENEMY = 148

DataSection
  clevel_1:
  Data.w -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,104,103,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,104,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,87,-1,91,91,91,108,91,91,91,91,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,148,86,-1,-1,-1,134,148,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,3,4,4,4,4,4,4,5,56,-1,15,16,-1,56,56,56,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,87,-1,-1,-1,-1,-1,-1,131,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,20,21,21,21,21,22,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,104,-1,-1,-1,-1,-1,103,104,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,104,-1,103,-1,-1,-1,-1,104,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,-1,88,-1,9,7,7,7,7,7,7,11,-1,-1,-1,-1,-1,-1,-1,-1,46,46,46,46,46,46,46,46,46,-1,-1,-1,-1,-1,-1,-1,-1,88,-1,26,27,27,27,27,28,-1,-1,-1,-1,-1,-1,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23
EndDataSection

Structure DataArray
   feld.w[0]   
EndStructure 

Global *level_1.DataArray = ?clevel_1

Global Dim borderTiles.w(79)
For i = 0 To 77
  borderTiles(i) = i
Next i

Global.b play = #False

Global.b space = #False

Global.b snow_stop = #False
Global.b draw_event_text = #True

Global.b ko = 0

Global DFont = LoadFont(#PB_Any, "Arial", 11)

Declare Tb_loadSprites()
Declare.b Tb_checkColPoint(x1.l, y1.l, x2.l, y2.l, w.l, h.l)
Declare.b Tb_checkCollision(x1.l, y1.l, x2.l, y2.l, x3.l, y3.l, x4.l, y4.l)
Declare.b Tb_checkColRect(x1.l, y1.l, w1.l, h1.l, x3.l, y3.l, w2.l, h2.l)
Declare.b Tb_checkColRectTol(x1.l, y1.l, w1.l, h1.l, x3.l, y3.l, w2.l, h2.l, tol.l)
Declare Tb_pumpTimer()
Declare.w Tb_getFrame(frame.w, min.w, max.w, steps.w)
Declare Tb_plotFrame(spr.l, frame.l, x.l, y.l, vx.l = 0, vy.l = 0)
Declare.b Sprite_moveAndCheckBorders(*s.TObject, z.l = 0)
Declare Sprite_jnrMove(*s.TObject)
Declare Sprite_checkSpritesActor(*s.TObject)
Declare.b Sprite_checkColSprites(*s1.TObject, *s2.TObject)
Declare Sprite_putOnScreen(*s.TObject, v_xt = 0, v_yt = 0)
Declare.b Sprite_checkForScreen(*s.TObject)
Declare Sprite_showExplosion(z.l)
Declare Player_set(pos_x.l, pos_y.l, depth.w = 1)
Declare Player_move()
Declare Player_jnr()
Declare Player_checkForTiles()
Declare Player_checkCollide()
Declare Player_fire()
Declare Player_scrollMap()
Declare Player_draw(v_xt = 0, v_yt = 0)
Declare Bullet_set(pos_x.l, pos_y.l, spd_x.l, spd_y.l, depth.w = 1)
Declare Bullet_draw(v_xt = 0, v_yt = 0)
Declare Enemy_set(z.l, pos_x.l, pos_y.l, depth.w = 1)
Declare Enemy_moveRnd_LR(z.l)
Declare Enemy_draw(z.l, v_xt = 0, v_yt = 0)
Declare Level_generateMap(level_nr.l)
Declare Level_drawParallaxBackground(v_xt.l = 0, v_yt.l = 0)
Declare Level_drawTiles(v_xt.l = 0, v_yt.l = 0)
Declare Level_drawEnemys(v_xt.l = 0, v_yt.l = 0)
Declare.b Level_checkBorderTiles(*s.TObject)
Declare Level_posSprite(tileNr.w)
Declare.l Level_getTile(*s.TObject)
Declare Level_setTile(*s.TObject, newTile.w)
Declare Game_drawHUD()
Declare Game_init()
Declare Game_reload()
Declare Game_drawGame()
Declare Game_play()
Declare Game_thread()
Declare Clean_GameObjects()


Procedure Tb_loadSprites()
  sprPlayer = LoadSprite(#PB_Any, "gfx/actor.png", #PB_Sprite_AlphaBlending)
  sprEnemy = LoadSprite(#PB_Any, "gfx/alien.png", #PB_Sprite_AlphaBlending)
  sprBullet = LoadSprite(#PB_Any, "gfx/bullet.png", #PB_Sprite_AlphaBlending)
  sprPlattform = LoadSprite(#PB_Any, "gfx/plattform.png", #PB_Sprite_AlphaBlending)
  sprTiles = LoadSprite(#PB_Any, "gfx/tileset-platformer-ice2.png", #PB_Sprite_AlphaBlending)
  sprExplosion = LoadSprite(#PB_Any, "gfx/explosion.png", #PB_Sprite_AlphaBlending)
  sprBackground = LoadSprite(#PB_Any, "gfx/background.png", #PB_Sprite_AlphaBlending)
  sprSchnee = LoadSprite(#PB_Any, "gfx/snowsmall.png", #PB_Sprite_AlphaBlending)
EndProcedure

Procedure.b Tb_checkColPoint(x1.l, y1.l, x2.l, y2.l, w.l, h.l)
  If ((x1 > x2) And (x1 < (x2 + w)) And (y1 > y2) And (y1 < (y2 + h)))
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.b Tb_checkCollision(x1.l, y1.l, x2.l, y2.l, x3.l, y3.l, x4.l, y4.l)
  If ((x2 >= x3) And (x4 >= x1) And (y2 >= y3) And (y4 >= y1))
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.b Tb_checkColRect(x1.l, y1.l, w1.l, h1.l, x3.l, y3.l, w2.l, h2.l)
  x2.l = x1 + w1 : y2.l = y1 + h1 ; Rechteck 1: Punkt rechts unten!
  x4.l = x3 + w2 : y4.l = y3 + h2 ; Rechteck 2: Punkt rechts unten!
  ProcedureReturn Tb_checkCollision(x1, y1, x2, y2, x3, y3, x4, y4)
EndProcedure

Procedure.b Tb_checkColRectTol(x1.l, y1.l, w1.l, h1.l, x3.l, y3.l, w2.l, h2.l, tol.l)
  x3 = x3 + tol / 2 : y3 = y3 + tol / 2 ; Toleranz anwenden
  w2 = w2 - tol : h2 = h2 - tol             ; Toleranz anwenden
  x2.l = x1 + w1 : y2.l = y1 + h1           ; Rechteck 1: Punkt rechts unten!
  x4.l = x3 + w2 : y4.l = y3 + h2           ; Rechteck 2: Punkt rechts unten!
  ProcedureReturn Tb_checkCollision(x1, y1, x2, y2, x3, y3, x4, y4)
EndProcedure

Procedure Tb_pumpTimer()
  timer = timer + 1
  If timer > 127
    timer = 0
  EndIf
EndProcedure

Procedure.w Tb_getFrame(frame.w, min.w, max.w, steps.w)
  If ((frame < min) Or (frame > max))
    frame = min
  EndIf
  If steps < 1
    steps = 1
  EndIf
  If timer%steps = 0
    frame = frame + 1
    If frame > max
      frame = min
    EndIf
  EndIf
  ProcedureReturn frame
EndProcedure

Procedure Tb_plotFrame(spr.l, frame.l, x.l, y.l, vx.l = 0, vy.l = 0)
  If spr = sprPlayer
    If frame < 10
      ClipSprite(spr, 13*frame, 0, 13, 23)
    EndIf
  ElseIf spr = sprEnemy
    ClipSprite(spr, 12*frame, 0, 12, SpriteHeight(spr))
  ElseIf spr = sprSchnee
    ClipSprite(spr, 11*frame, 0, 11, SpriteHeight(spr))
  ElseIf spr = sprTiles
    If frame < 10
      ClipSprite(spr, 32*frame, 0, 32, 32)
    EndIf
    If frame > 9 And frame < 20
      ClipSprite(spr, (32*(frame-10)), 32, 32, 32)
    EndIf
    If frame > 19 And frame < 30
      ClipSprite(spr, (32*(frame-20)), 64, 32, 32)
    EndIf
    If frame > 29 And frame < 40
      ClipSprite(spr, (32*(frame-30)), 96, 32, 32)
    EndIf
    If frame > 39 And frame < 50
      ClipSprite(spr, (32*(frame-40)), 128, 32, 32)
    EndIf
    If frame > 49 And frame < 60
      ClipSprite(spr, (32*(frame-50)), 160, 32, 32)
    EndIf
    If frame > 59 And frame < 70
      ClipSprite(spr, (32*(frame-60)), 192, 32, 32)
    EndIf
    If frame > 69 And frame < 80
      ClipSprite(spr, (32*(frame-70)), 224, 32, 32)
    EndIf
    If frame > 79 And frame < 90
      ClipSprite(spr, (32*(frame-80)), 256, 32, 32)
    EndIf
    If frame > 89 And frame < 100
      ClipSprite(spr, (32*(frame-90)), 288, 32, 32)
    EndIf
    If frame > 99 And frame < 110
      ClipSprite(spr, (32*(frame-100)), 320, 32, 32)
    EndIf
    If frame > 109 And frame < 120
      ClipSprite(spr, (32*(frame-110)), 352, 32, 32)
    EndIf
    If frame > 119 And frame < 130
      ClipSprite(spr, (32*(frame-120)), 384, 32, 32)
    EndIf
    If frame > 129 And frame < 140
      ClipSprite(spr, (32*(frame-130)), 416, 32, 32)
    EndIf
    If frame > 139 And frame < 150
      ClipSprite(spr, (32*(frame-140)), 448, 32, 32)
    EndIf
    If frame > 149 And frame < 160
      ClipSprite(spr, (32*(frame-150)), 480, 32, 32)
    EndIf
  ElseIf spr = sprExplosion
    ClipSprite(spr, 15*frame, 0, 15, SpriteHeight(spr))
  EndIf
  DisplayTransparentSprite(spr, x + vx, y + vy)
EndProcedure

Procedure Schnee_init()
  Global numImage = 1 : Global numFlakes = 20
  Global Dim flake_x(numFlakes) : Global Dim flake_y(numFlakes)
  Global Dim flake_speed(numFlakes)
  Global Dim flake_step(numFlakes) : Global Dim flake_step2(numFlakes)
  For i = 0 To numFlakes
    flake_x(i) = Random(ScreenWidth(),0)
    flake_y(i) = Random(ScreenHeight(),0)
    flake_speed(i) = Random(6,3)
    flake_step(i) = Random(15,5)
    flake_step2(i) = 0
  Next i
EndProcedure

Procedure Schnee_Simulation()
  ;Let it snow!!!
  If snow_stop = #False
    For i = 0 To numFlakes
      speed_x = flake_speed(i)*Cos(flake_step2(i))/2
      speed_y = flake_speed(i)*Sin(90*#PI/180)
      flake_x(i) + speed_x
      flake_y(i) + speed_y
      If flake_y(i) > ScreenHeight()
        flake_x(i) = Random(ScreenWidth(),0) + player\x
        flake_y(i) = -100
        flake_speed(i) = Random(6,3)
      EndIf
      ;Tb_plotFrame(sprSchnee, 1, flake_x(i), flake_y(i), actor_xt, actor_yt)
      Tb_plotFrame(sprSchnee, 0, flake_x(i)-player\x, flake_y(i), actor_xt, flake_y(i)-actor_yt)
      flake_step2(i) + flake_step(i)
    Next i
  EndIf
EndProcedure

Procedure.b Sprite_moveAndCheckBorders(*s.TObject, z.l = 0)
  If *s\type = #ENEMY
    If *s\dir = #S_LEFT
      *s\x = *s\x - *s\speed
    EndIf
    If *s\dir = #S_RIGHT
      *s\x = *s\x + *s\speed
    EndIf
    If Level_checkBorderTiles(@enemy(z)) Or Sprite_checkSpritesActor(@s)
      If *s\dir = #S_UP
        *s\y = *s\y + *s\speed
      EndIf
      If *s\dir = #S_DOWN
        *s\y = *s\y - *s\speed
      EndIf
      If *s\dir = #S_LEFT
        *s\x = *s\x + *s\speed
      EndIf
      If *s\dir = #S_RIGHT
        *s\x = *s\x - *s\speed
      EndIf
      ProcedureReturn #False
    EndIf
  Else
    If *s\dir = #S_UP
      *s\y = *s\y - *s\speed
    EndIf
    If *s\dir = #S_DOWN
      *s\y = *s\y + *s\speed
    EndIf
    If *s\dir = #S_LEFT
      *s\x = *s\x - *s\speed
    EndIf
    If *s\dir = #S_RIGHT
      *s\x = *s\x + *s\speed
    EndIf
    If Level_checkBorderTiles(@s) Or Sprite_checkSpritesActor(@s)
      If *s\dir = #S_UP
        *s\y = *s\y + *s\speed
      EndIf
      If *s\dir = #S_DOWN
        *s\y = *s\y - *s\speed
      EndIf
      If *s\dir = #S_LEFT
        *s\x = *s\x + *s\speed
      EndIf
      If *s\dir = #S_RIGHT
        *s\x = *s\x - *s\speed
      EndIf
      ProcedureReturn #False
    EndIf
  EndIf
  ProcedureReturn #True
EndProcedure

Procedure Sprite_jnrMove(*s.TObject)
  If *s\jump
    Select *s\jumpStep
      Case 0
        *s\y = *s\y - (*s\speed + 5)
      Case 1
        *s\y = *s\y - (*s\speed + 5)
      Case 2
        *s\y = *s\y - (*s\speed + 5)
      Case 3
        *s\y = *s\y - (*s\speed + 4)
      Case 4
        *s\y = *s\y - (*s\speed + 4)
      Case 5
        *s\y = *s\y - (*s\speed + 3)
      Case 6
        *s\y = *s\y - (*s\speed + 3)
      Case 7
        *s\y = *s\y - (*s\speed + 2)
      Default
        *s\y = *s\y - *s\speed
    EndSelect
    *s\jumpStep = *s\jumpStep + 1
    If *s\jumpStep > 8
      *s\jump = #False
      *s\fall = #True
      *s\jumpStep = 0
    EndIf
  ElseIf *s\fall
    Select *s\jumpStep
      Case 0
        *s\y = *s\y + *s\speed
      Case 1
        *s\y = *s\y + (*s\speed + 2)
      Case 2
        *s\y = *s\y + (*s\speed + 3)
      Case 3
        *s\y = *s\y + (*s\speed + 3)
      Case 4
        *s\y = *s\y + (*s\speed + 4)
      Case 5
        *s\y = *s\y + (*s\speed + 5)
      Case 6
        *s\y = *s\y + (*s\speed + 6)
      Case 7
        *s\y = *s\y + (*s\speed + 7)
      Default
        *s\y = *s\y + (*s\speed + 8)
    EndSelect
    *s\jumpStep = *s\jumpStep + 1
  EndIf
EndProcedure

Procedure Sprite_checkSpritesActor(*s.TObject)
  hit.b = Sprite_checkColSprites(@s, @player)
  If hit
    player\hit = #True
    *s\hit = #True
  EndIf
  ProcedureReturn hit
EndProcedure

Procedure.b Sprite_checkColSprites(*s1.TObject, *s2.TObject)
  tol.l = 5
  hit.b = Tb_checkColRectTol(*s1\x, *s1\y, *s1\w, *s1\h, *s2\x, *s2\y, *s2\w, *s2\h, tol)
  ProcedureReturn hit
EndProcedure

Procedure Sprite_putOnScreen(*s.TObject, v_xt = 0, v_yt = 0)
  If Not *s\hit
    *s\frame = Tb_getFrame(*s\frame, *s\min, *s\max, *s\steps)
    Tb_plotFrame(*s\id, *s\frame, *s\x, *s\y + 1, v_xt, v_yt)
  EndIf
EndProcedure

Procedure.b Sprite_checkForScreen(*s.TObject)
  If *s\drawAlways
    ProcedureReturn #True
  EndIf
  If *s\x = #OUT
    ProcedureReturn #False
  EndIf
  ProcedureReturn Tb_checkColRect(*s\x, *s\y, *s\w, *s\h, -actor_xt, -actor_yt, tb\w, tb\h)
EndProcedure

Procedure Sprite_showExplosion(z.l)
  If enemy(z)\hit = #True
    If explosionTime = 0 And ko = 0
      AddWindowTimer(0,789,60) ;Explosions-Timer
      ko = 1
    EndIf
    If explosionTime < 4 And explosionTime > 0
      Tb_plotFrame(sprExplosion, explosionTime, enemy(z)\x, enemy(z)\y, xt, yt)
    EndIf
    If explosionTime = 3
      enemy(z)\x = #OUT : enemy(z)\y = #OUT
    EndIf
    If explosionTime = 4
      explosionTime = 0
      RemoveWindowTimer(0,789)
      If ListSize(bullet()) > 0
        DeleteElement(bullet())
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure Player_set(pos_x.l, pos_y.l, depth.w = 1)
  player\x = pos_x
  player\y = pos_y
  player\depth = depth
  player\type = #PLAYER
  player\id = sprPlayer
  player\frameAnz = 10
  player\min = 1
  player\max = 1
  player\steps = 2
  player\speed = 3
  player\hit = #False
  player\drawAlways = #False
  player\w  = SpriteWidth(sprPlayer) / player\frameAnz
  player\h = SpriteHeight(sprPlayer)
  player\eventFrame = 0
  player\jump = #False
  player\fall = #False
  player\jumpStep = 0
EndProcedure

Procedure Player_move()
  If Not player\hit
    border.l = Level_getTile(@player)
    If left Or upLeft
      player\x = player\x - player\speed
      If border = 87 Or border = 88
        player\min = 8 : player\max = 9
      Else
        player\min = 4 : player\max = 7
      EndIf
      If Level_checkBorderTiles(@player)
        player\x = player\x + player\speed
      EndIf
    EndIf
    If right Or upRight
      player\x = player\x + player\speed
      If border = 87 Or border = 88
        player\min = 8 : player\max = 9
      Else
        player\min = 0 : player\max = 3
      EndIf
      If Level_checkBorderTiles(@player)
        player\x = player\x - player\speed
      EndIf
    EndIf
    If border = 87 Or border = 88
      If up
        player\min = 8 : player\max = 9
        player\y = player\y - player\speed
      EndIf
      If down
        If border = 87 Or border = 88
          player\min = 8 : player\max = 9
          player\y = player\y + player\speed
          If Level_checkBorderTiles(@player)
            player\y = player\y - player\speed
          EndIf
        EndIf
      EndIf
    EndIf
    If Not (border = 87 Or border = 88) And Not jplatt
      Player_jnr()
    EndIf
    If fire
      ;fire = #False
      Player_fire()
    EndIf
    If (Not left) And (Not  right) And (Not up) And (Not down) And (Not upLeft) And (Not upRight)
      If player\min = 0
        player\min = 1 : player\max = 1
      EndIf
      If player\min = 4
        player\min = 5 : player\max = 5
      EndIf
      If player\min = 8
        player\min = 9 : player\max = 9
      EndIf
    EndIf
    Player_checkCollide()
    ;Player_checkForTiles()
  EndIf
EndProcedure

Procedure Player_jnr()
  If ((up Or upLeft Or upRight) And (Not player\jump) And (Not player\fall)) ;Jump auslösen
    player\jump = #True
  ElseIf Not player\jump
    player\fall = #True
  EndIf
  Sprite_jnrMove(@player)
  If (player\jump) And (Not player\fall) ;Jump
    If Level_checkBorderTiles(@player)
      top.l = (player\y/#RASTER) * #RASTER + #RASTER ;Eichung
      player\y = top                                ;Figur ist nun bündig mit der Decke
      player\jump = #False
      player\fall = #True
      player\jumpStep = 0
    EndIf
  EndIf
  If (player\fall) And (Not player\jump) ;Fall
    If Level_checkBorderTiles(@player)
      bottom.l = ((player\y + player\h)/#RASTER) * #RASTER ;Eichung
      player\y = bottom - player\h - 1                   ;Figur steht nun bündig auf dem Boden (1px Abstand)
      player\fall = #False
      player\jumpStep = 0
    EndIf
  EndIf
EndProcedure

Procedure Player_checkForTiles()
  colOb.l = Level_getTile(@player)
  If colOb = #L_MINE
    score = score + 150
    minesLeft = minesLeft - 1
    Level_setTile(@player, #L_EMPTY)
  EndIf
EndProcedure

Procedure Clean_GameObjects()
  FreeSprite(sprPlayer) : FreeSprite(sprEnemy) : FreeSprite(sprBullet)
  FreeSprite(sprPlattform) : FreeSprite(sprTiles) : FreeSprite(sprExplosion)
  FreeSprite(sprBackground) : FreeSprite(sprSchnee)
EndProcedure

Procedure Player_checkCollide()
  If Sprite_checkColSprites(@player, @enemy(0)) Or Sprite_checkColSprites(@player, @enemy(1))
    lifes - 1
    Game_reload()
  EndIf
EndProcedure

Procedure Player_fire()
  If Not player\hit
    If fire = #True And ammo > 0
      AddElement(bullet())
      If player\min = 0 Or player\min = 1
        player\dir = #S_RIGHT
        Bullet_set(player\x, player\y + 5, 4, 0)
      EndIf
      If player\min = 4 Or player\min = 5
        player\dir = #S_LEFT
        Bullet_set(player\x, player\y + 5, -4, 0)
      EndIf
      fire = #False
      ammo - 1
    EndIf
  EndIf
EndProcedure

Procedure Player_scrollMap()
  xt = -player\x + (tb\w / 5)
  yt = (tb\h / 2 - player\h / 2) - player\y
EndProcedure

Procedure Player_draw(v_xt = 0, v_yt = 0)
  If Not player\hit
    Sprite_putOnScreen(@player, v_xt, v_yt)
  EndIf
EndProcedure

Procedure Bullet_set(pos_x.l, pos_y.l, spd_x.l, spd_y.l, depth.w = 1)
  bullet()\x = pos_x
  bullet()\y = pos_y
  bullet()\type = #BULLET
  bullet()\id = sprBullet
  bullet()\frameAnz = 1
  bullet()\eventFrame = 0
  bullet()\w  = SpriteWidth(bullet()\id) / bullet()\frameAnz
  bullet()\h = SpriteHeight(bullet()\id)
  bullet()\spd_x = spd_x
  bullet()\spd_y = spd_y
  bullet()\hit = #False
  bullet()\depth = depth
EndProcedure

Procedure Bullet_draw(v_xt = 0, v_yt = 0)
  If ListSize(bullet()) > 0
    ForEach bullet()
      col = Level_checkBorderTiles(@bullet())
      If Sprite_checkColSprites(@bullet(), @enemy(0))
        score = score + 15
        enemy(0)\hit = #True
        bullet()\hit = #True
        ko = 0
        DeleteElement(bullet())
      ElseIf Sprite_checkColSprites(@bullet(), @enemy(1))
        score = score + 15
        enemy(1)\hit = #True
        bullet()\hit = #True
        ko = 0
        DeleteElement(bullet())
      ElseIf bullet()\x <= 0 Or bullet()\x >= tb\w Or col
        ;Level_setTile(@bullet(), #L_EMPTY)
        bullet()\hit = #True
        DeleteElement(bullet())
      Else
        bullet()\x = bullet()\x + bullet()\spd_x 
        bullet()\y = bullet()\y + bullet()\spd_y 
        ;DisplaySprite(sprBullet, bullet()\x+v_xt, bullet()\y+v_yt)
        If bullet()\hit = #False
          Sprite_putOnScreen(@bullet(), v_xt, v_yt)
        EndIf
      EndIf
    Next bullet()
  EndIf
EndProcedure

Procedure Enemy_set(z.l, pos_x.l, pos_y.l, depth.w = 1)
  enemy(z)\type = #ENEMY
  enemy(z)\id = sprEnemy
  enemy(z)\frameAnz = 8
  enemy(z)\speed = 1
  enemy(z)\dir = #S_LEFT
  enemy(z)\w  = SpriteWidth(enemy(z)\id) / enemy(z)\frameAnz
  enemy(z)\h = SpriteHeight(enemy(z)\id)
  enemy(z)\eventFrame = 0
  enemy(z)\hit = #False
  enemy(z)\x = pos_x
  enemy(z)\y = pos_y
  enemy(z)\depth = depth
  enemy(z)\min = 1
  enemy(z)\max = 1
  enemy(z)\steps = 2
  enemy(z)\drawAlways = #False
  enemy(z)\jump = #False
  enemy(z)\fall = #False
  enemy(z)\jumpStep = 0
EndProcedure

Procedure Enemy_moveRnd_LR(z.l)
  ;Fallen
  enemy(z)\fall = #True
  Sprite_jnrMove(@enemy(z))
  If Level_checkBorderTiles(@enemy(z)) ;kein Fall
    enemy(z)\fall = #False
    enemy(z)\jumpStep = 0
    bottom.l = ((enemy(z)\y + enemy(z)\h)/#RASTER)*#RASTER ; Eichung
    enemy(z)\y = bottom - enemy(z)\h - 1                   ;Figur steht nun bündig auf dem Boden (1px Abstand)
                                             ; Änderung der Richtung
    If Random(1000,0)%25 = 0
      enemy(z)\dir = Random(1,0)+2
    EndIf
    loop.w = 0 ; Abbruchbedingung
    While Not Sprite_moveAndCheckBorders(@enemy(z), z)
      enemy(z)\dir = Random(1,0)+2
      loop = loop + 1
      If loop > 3
        Break ; max 4x prüfen
      EndIf
    Wend
  Else 
    Sprite_checkSpritesActor(@enemy(z)) ; während des Falles trozdem durchführen
  EndIf
EndProcedure

Procedure Enemy_draw(z.l, v_xt = 0, v_yt = 0)
  If Not enemy(z)\hit
    Enemy_moveRnd_LR(z)
    If enemy(z)\dir = #S_LEFT
      enemy(z)\min = 4 : enemy(z)\max = 7
    EndIf
    If enemy(z)\dir = #S_RIGHT
      enemy(z)\min = 0 : enemy(z)\max = 3
    EndIf
    Sprite_putOnScreen(@enemy(z), v_xt, v_yt)
  EndIf
EndProcedure

Procedure Plattform_set(z.l, pos_x.l, pos_y.l, dir.w, speed.w)
  plattform(z)\x = pos_x
  plattform(z)\y = pos_y
  plattform(z)\id = sprPlattform
  plattform(z)\frameAnz = 1
  plattform(z)\speed = speed
  plattform(z)\dir = dir
  plattform(z)\w  = SpriteWidth(plattform(z)\id) / plattform(z)\frameAnz
  plattform(z)\h = SpriteHeight(plattform(z)\id)
  plattform(z)\hit = #False
  plattform(z)\eventFrame = 0
EndProcedure

Procedure Plattform_move(z.l)
  If left Or upLeft
    If Sprite_checkColSprites(@plattform(z), @player)
      jplatt = #True
    EndIf
  EndIf
  If right Or upRight
    If Sprite_checkColSprites(@plattform(z), @player)
      jplatt = #True
    EndIf
  EndIf
  If jplatt
    player\x = plattform(z)\x + 5 : player\y = plattform(z)\y - 20
  EndIf
  border.l = Level_getTile(@plattform(z))
  If border = 104
    plattform(z)\speed = 0
    If plattform(z)\dir = #S_LEFT
      plattform(z)\dir = #S_RIGHT
    ElseIf plattform(z)\dir = #S_RIGHT
      plattform(z)\dir = #S_LEFT
    EndIf
    plattform(z)\speed = 1
  EndIf
  If plattform(z)\dir = #S_UP
    plattform(z)\y + plattform(z)\speed
  ElseIf plattform(z)\dir = #S_DOWN
    plattform(z)\y - plattform(z)\speed
  ElseIf plattform(z)\dir = #S_LEFT
    plattform(z)\x - plattform(z)\speed
  ElseIf plattform(z)\dir = #S_RIGHT
    plattform(z)\x + plattform(z)\speed
  EndIf
EndProcedure

Procedure Plattform_draw(z.l, v_xt = 0, v_yt = 0)
  Sprite_putOnScreen(@plattform(z), v_xt, v_yt)
EndProcedure

Procedure Level_generateMap(level_nr.l)
  If level_nr = 1
    tiles_w = 50 : tiles_h = 20
  EndIf
  byte_nr.l = 0
  For h = 0 To (tiles_h - 1)
    For w = 0 To (tiles_w - 1)
      If level_nr = 1
        levelMap(h, w) = *level_1\feld[byte_nr]
      EndIf
      byte_nr = byte_nr + 1
    Next w
  Next h
EndProcedure

Procedure Level_drawParallaxBackground(v_xt.l = 0, v_yt.l = 0)
  If init
    init = #False
    bg_w = SpriteWidth(sprBackground)
    bg_h = SpriteHeight(sprBackground)
  EndIf
  ;Positionsänderung des Spielers ermitteln
  diffX.l = actor_xt - actorOldxt
  diffY.l = actor_yt - actorOldyt
  actorOldxt = actor_xt ;Buffer
  actorOldyt = actor_yt
  ;Parralax-Ebene verschieben
  bg_x = bg_x - diffX/2
  bg_y = bg_y - diffY/2
  ;Grenzen für Referenzpunkt
  If bg_x > bg_w
    bg_x = 0
  EndIf
  If bg_x < 0
    bg_x = bg_w
  EndIf
  If bg_y > bg_h
    bg_y = 0
  EndIf
  If bg_y < 0
    bg_y = bg_h
  EndIf
  For x = (-actor_xt - bg_x) To ((-actor_xt + tb\w)-1)
    For y = (-actor_yt - bg_y) To ((-actor_yt + tb\h)-1)
      Tb_plotFrame(sprBackground, 0, x, y, v_xt, v_yt)
      y = (y + bg_h)
    Next y
    x = (x + bg_w)
  Next x
EndProcedure

Procedure Level_drawTiles(v_xt.l = 0, v_yt.l = 0)
  Level_drawParallaxBackground(v_xt-(tb\w/4), v_yt-(tb\h/4))
  Schnee_Simulation()
  For x = -actor_xt To ((actor_xt + tb\w)-1)
    For y = -actor_yt To ((actor_yt + tb\h)-1)
      x = x/#RASTER : y = y/#RASTER : x = x * #RASTER : y = y * #RASTER ; Eichung
      If ((x >= 0) And (x < (tiles_w * #RASTER)) And (y >= 0) And (y < (tiles_h * #RASTER)))
        tileNr.l = levelMap(y/#RASTER, x/#RASTER)
        If tileNr <> #L_EMPTY
          Tb_plotFrame(sprTiles, tileNr, x, y, v_xt, v_yt)
        EndIf
      EndIf
      y = (y+#RASTER)-1
    Next y
    x = (x+#RASTER)-1
  Next x
EndProcedure

Procedure Level_drawEnemys(v_xt.l = 0, v_yt.l = 0)
  For anz = 0 To enemy_anz-1
    Enemy_draw(anz, v_xt, v_yt)
  Next anz
EndProcedure

Procedure.b Level_checkBorderTiles(*s.TObject)
  x1.l = *s\x : y1.l = *s\y ; PNG-Punkt oben links!
  x2.l = *s\x + *s\w : y2.l = *s\y ; PNG-Punkt oben rechts!
  x3.l = *s\x : y3.l = *s\y + *s\h ; PNG-Punkt unten links!
  x4.l = *s\x + *s\w : y4.l = *s\y + *s\h ; PNG-Punkt unten rechts!
  
  colObOL.l = levelMap(y1/#RASTER, x1/#RASTER)
  colObOR.l = levelMap(y2/#RASTER, x2/#RASTER)
  colObUL.l = levelMap(y3/#RASTER, x3/#RASTER)
  colObUR.l = levelMap(y4/#RASTER, x4/#RASTER)
  
  For i = 0 To (ArraySize(borderTiles()))
    If colObOL = borderTiles(i)
      ProcedureReturn #True
    EndIf
    If colObOR = borderTiles(i)
      ProcedureReturn #True
    EndIf
    If colObUL = borderTiles(i)
      ProcedureReturn #True
    EndIf
    If colObUR = borderTiles(i)
      ProcedureReturn #True
    EndIf
  Next i
  ProcedureReturn #False
EndProcedure

Procedure Level_posSprite(tileNr.w)
  anz.l = 0
  For h = 0 To (tiles_h - 1)
    For w = 0 To (tiles_w - 1)
      If levelMap(h, w) = tileNr
        If tileNr = #L_PLAYER
          player\x = w * #RASTER
          player\y = h * #RASTER
        EndIf
        If tileNr = #L_ENEMY
          Enemy_set(anz, (w * #RASTER), (h * #RASTER))
          anz = anz + 1
          enemy_anz = anz
        EndIf
        If tileNr = 103
          plattform(anz)\x = w * #RASTER
          plattform(anz)\y = h * #RASTER
          anz = anz + 1
          plattform_anz = anz
        EndIf
      EndIf
    Next w
  Next h
EndProcedure

Procedure Level_switchTile(oldTile.w, newTile.w)
  For h = 0 To (tiles_h - 1)
    For w = 0 To (tiles_w - 1)
      If levelMap(h, w) = oldTile
        levelMap(h, w) = newTile
      EndIf
    Next w
  Next h
EndProcedure

Procedure.l Level_getTile(*s.TObject)
  mpX.l = *s\x + *s\w /2 : mpY.l = *s\y + *s\h / 2 ;Mittelpunkt des Sprites
  colOb.l = levelMap(mpY/#RASTER, mpX/#RASTER)
  ProcedureReturn colOb
EndProcedure

Procedure Level_setTile(*s.TObject, newTile.w)
  mpX.l = *s\x + *s\w /2 : mpY.l = *s\y + *s\h / 2 ;Mittelpunkt des Sprites
  levelMap(mpY/#RASTER, mpX/#RASTER) = newTile
EndProcedure

Procedure Partikel_Test()
  LoadTexture(0, "flare.png")
  
  CreateMaterial(0, TextureID(0))
  DisableMaterialLighting(0, 1)
  MaterialBlendingMode   (0, #PB_Material_Add)
  
  CreateParticleEmitter(0, 10, 1, 1, 0)
  ParticleMaterial    (0, MaterialID(0))
  ParticleTimeToLive  (0, 2, 2)
  ParticleEmissionRate(0, 20)
  ParticleSize        (0, 30, 30)
  ParticleColorRange  (0, RGB(255,0,0), RGB(255, 0, 255))
  
  CreateParticleEmitter(1, 10, 1, 1, 0)
  ParticleMaterial    (1, MaterialID(0))
  ParticleTimeToLive  (1, 2, 2)
  ParticleEmissionRate(1, 20)
  ParticleSize        (1, 30, 30)
  ParticleColorRange  (1, RGB(255, 255, 0), RGB(0, 255, 0))
  
  MoveParticleEmitter(1, -50, 0, 0)
EndProcedure

Procedure Animate_tiles()
  back.l = Level_getTile(@player)
  If back = 134
    Level_setTile(@player, 133)
  EndIf
EndProcedure

Procedure Game_drawHUD()
  DrawingMode(1)
  Box(0,0,ScreenWidth(),ScreenHeight(),#Black)
  DrawingFont(FontID(DFont))
  FrontColor(RGB(0,0,0)) : Box(0, 570, 800, 30)     
  
  FrontColor(RGB(200,200,200)) 
  DrawText(340, 10, Str(lifes))
  DrawText(80, 10, Str(score))
  DrawText(600, 10, Str(1))   ;Neu, der aktuelle Level wird nun auch angezeigt
  
  FrontColor(RGB(200,100,0)) 
  DrawText(280, 10, "Lives:")
  DrawText(10, 10, "Score:")
  DrawText(540, 10, "Level:")
EndProcedure

Procedure Game_init()
  Schnee_init()
  Player_set(120, 0)
  Enemy_set(0,410,0)
  Plattform_set(0, 0, 0, #S_RIGHT, 1)
  Plattform_set(1, 0, 0, #S_LEFT, 1)
  Plattform_set(2, 0, 0, #S_RIGHT, 1)
  Level_generateMap(1)
  Level_posSprite(103)
  Level_posSprite(#L_ENEMY)
  ;Level_posSprite(#L_PLAYER)
  
  play = #True
EndProcedure

Procedure Game_drawGame()
  ClearScreen(RGB(0,0,0))
  ;Box(0, 0, ScreenWidth(), ScreenHeight(), RGB(0,0,0))
  Tb_pumpTimer()
EndProcedure

Procedure GameEvent_drawText()
  If snow_stop = #True And draw_event_text = #True
    FrontColor(RGB(200,200,200)) 
    DrawText(60, 200, "Der Schneefall stoppt nach 20 Sekunden.")
  EndIf
EndProcedure

Procedure Game_play()
  If play = #True
    If Not player\hit
      Player_move()
    EndIf
    Player_scrollMap()
    Level_drawTiles(xt, yt)
    Bullet_draw(xt, yt)
    ;Schnee_Simulation()
    ;Partikel_Test()
    Animate_tiles()
    
    Player_draw(xt, yt)
    Plattform_move(0)
    Plattform_draw(0, xt, yt)
    Plattform_move(1)
    Plattform_draw(1, xt, yt)
    Plattform_move(2)
    Plattform_draw(2, xt, yt)
    ;Enemy_draw(0, xt, yt)
    Level_drawEnemys(xt, yt)
    Sprite_showExplosion(0)
    Sprite_showExplosion(1)
    screenTimer = 0
  EndIf
EndProcedure

Procedure Game_reload()
  play = #False
  player\hit = #True
  player\x = #OUT
  player\y = #OUT
  Clean_GameObjects()
  Tb_loadSprites()
  Game_init()
EndProcedure

Procedure Game_sound()
  LoadSound(0,"snd\hsound.ogg",#PB_Sound_Streaming)
  PlaySound(0,#PB_Sound_Loop)
EndProcedure

Procedure OpenDrawWindow()
  If OpenWindow(0, 0, 0, 640, 400, "Mein kleines Jumpi-Game", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    SetWindowColor(0, RGB(0,0,0))
    AddWindowTimer(0,123,20000) ;Schnee-Timer
    AddWindowTimer(0,456,5000)  ;Ammo-Timer
    OpenWindowedScreen(WindowID(0), 5, 5, WindowWidth(0)-20, WindowHeight(0)-20, 0, 0, 0)
    ;OpenScreen(640, 480, 32, "Mein kleines Jumpi-Game")
    CreateCamera(0, 0, 0, 100, 100)
    MoveCamera(0, 0, 0, 100, #PB_Absolute)
    OpenWindow3D(1, 50, 50, 300, 300, "Error-DEBUG-Window")
    ShowGUI(0,0,0,1)
    ;Partikel_Test()
    Global renderView = CreateSprite(#PB_Any,ScreenWidth(),ScreenHeight())
    While WindowEvent3D() : Wend
    Game_sound()
  EndIf
EndProcedure

Procedure Game_thread()
  tb\w = 1600
  tb\h = 700
  SetFrameRate(#MAX_GAME_SPEED)
  ReleaseMouse(#True)
  Tb_loadSprites()
  Game_init()
  Repeat
    If play = #True
    Repeat
      Event = WindowEvent()
      
      Select Event
        Case #PB_Event_CloseWindow
          Quit = 1
          
        Case #PB_Event_Timer
          If EventTimer() = 123
            If snow_stop = #False
              snow_stop = #True
              RemoveWindowTimer(0, 123)
              AddWindowTimer(0, 123, 2000)
            Else
              draw_event_text = #False
            EndIf
          EndIf
          If EventTimer() = 456
            ammo = 5 ;Ammo-Reload
          EndIf
          If EventTimer() = 789
            explosionTime + 1
          EndIf

        Case #PB_Event_Gadget
          Gadget = EventGadget()
          Select Gadget
              
          EndSelect
      EndSelect
    Until Event = 0
    
    RenderWorld()
    
    Game_drawGame()
    Game_play()
    
    If renderView
      If StartDrawing(SpriteOutput(renderView))
            DrawingMode(#PB_2DDrawing_AlphaChannel)
            Box(0, 0, SpriteWidth(renderView), SpriteHeight(renderView), #Black)
            Game_drawHUD()
            GameEvent_drawText()
            StopDrawing()
        EndIf
        DisplayTransparentSprite(renderView,0,0)
    EndIf
    
    ; Sprite & Screen -Management bei jedem Bild(Frame)
    ExamineKeyboard()
    
    If KeyboardPushed(#PB_Key_Up)
      up = #True
    EndIf  
    If KeyboardPushed(#PB_Key_Down)
      down = #True
    EndIf
    If KeyboardPushed(#PB_Key_Left)
      left = #True
    EndIf  
    If KeyboardPushed(#PB_Key_Right)
      right = #True
    EndIf
    If KeyboardPushed(#PB_Key_Space)
      If space = #False 
        space = #True
        fire = #True
        Player_fire()
      EndIf
    EndIf
    
    If KeyboardReleased(#PB_Key_Up)
      up = #False
    EndIf
    If KeyboardReleased(#PB_Key_Down)
      down = #False
      jplatt = #False
    EndIf
    If KeyboardReleased(#PB_Key_Left)
      left = #False
    EndIf  
    If KeyboardReleased(#PB_Key_Right)
      right = #False
    EndIf
    If KeyboardReleased(#PB_Key_Space)
      fire = #False
      space = 0
    EndIf
    If KeyboardReleased(#PB_Key_R)
      Game_reload()
    EndIf 
    
    FlipBuffers()
    EndIf
  Until  Quit Or KeyboardPushed(#PB_Key_Escape)
EndProcedure

OpenDrawWindow()
Game_thread()
CloseWindow3D(1)
CloseScreen()
End

; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; Folding = ----------
; EnableUnicode
; EnableThread
; EnableXP
; Executable = ..\jumpi0x